      *****************************************************************
      *               LONAPFFL.CPY - a COBOL Copy File                *
      *     Record Layout for the File Properties Repository          *
      *  The record stucture is a fixed length of 1,024 characters    *
      *         Copyright (C) 1987-2019 SimoTime Technologies         *
      *                     All Rights Reserved                       *
      *              Provided by SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *  The information that is imported into this format originates
      *  from an Excel spreadsheet. The spreadsheet is saved to an
      *  ASCII/Text File with a Comma-Separated-Values (or CSV) record
      *  structure.
      *
      *  LONAP is an acronym for a List Of Names And Properties.
      *  CSV   is an acronym for Comma-Separated-Values.
      *  FFL   is an acronym for Fixed-Field-Length.
      *
      *  A conversion program is used to convert the CSV File to a
      *  Record Sequential File with the following Fixed Field format.
      *
      *  The fields are all fixed length.
      *  Numeric fields are right-adjusted with leading zeroes.
      *  Alpha-numeric fields are left adjusted with trailing spaces.
      *
      *  Positions 73-80 of the following statements are used to
      *  identify the original columns used in the Excel spreadsheet.
      *
       01  LONAPFFL-REC.                                                Excel
           05  LONAPFFL-LEVEL-CHR.
               10  LONAPFFL-LEVEL-NBR      PIC 9(2).                    col-A
           05  LONAPFFL-FILE-INFO.
               10  LONAPFFL-DSN            PIC X(54).                   col-B
               10  LONAPFFL-DD-NAME        PIC X(17).                   col-C
               10  LONAPFFL-DSORG          PIC X(4).                    col-D
               10  LONAPFFL-RECFM          PIC X(4).                    col-E
               10  LONAPFFL-LRECL-MIN      PIC 9(5).                    col-F
               10  LONAPFFL-LRECL-MAX      PIC 9(5).                    col-G
               10  LONAPFFL-KEYPOS         PIC 9(5).                    col-H
               10  LONAPFFL-KEYLEN         PIC 9(5).                    col-I
               10  LONAPFFL-VSAM-DAT       PIC X(58).                   col-J
               10  LONAPFFL-VSAM-IDX       PIC X(58).                   col-K
           05  LONAPFFL-JOB-EXEC.
               10  LONAPFFL-JCL-OVR1       PIC X(8).                    col-L
               10  LONAPFFL-JCL-USR1       PIC X(8).                    col-M
               10  LONAPFFL-JCL-USR2       PIC X(8).                    col-N
           05  LONAP-EXTENDED-GROUP.
               10  LONAPFFL-EXTENDED-S1    PIC X(4).                    col-O
               10  LONAPFFL-EXTENDED-S2    PIC X(4).                    col-P
               10  LONAPFFL-EXTENDED-M1    PIC X(16).                   col-Q
               10  LONAPFFL-EXTENDED-M2    PIC X(16).                   col-R
               10  LONAPFFL-EXTENDED-M3    PIC X(16).                   col-S
               10  LONAPFFL-EXTENDED-M4    PIC X(16).                   col-T
               10  LONAPFFL-EXTENDED-X1    PIC X(256).                  col-U
               10  LONAPFFL-EXTENDED-X2    PIC X(256).                  col-V
           05  FILLER                      PIC X(199).
      *
      ***  LONAPFFL - End-of-Copy File - - - - - - - - - - - LONAPFFL *
      *****************************************************************
      *
