       IDENTIFICATION DIVISION.
       PROGRAM-ID.    MFCATXPT.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1994-2012 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only does not imply publication or    *
      * disclosure.  This software contains confidential information  *
      * and trade secrets of SimoTime Technologies. No part of this   *
      * program or publication may be reproduced, transmitted,        *
      * transcribed, stored in a retrieval system, or translated into *
      * any language or computer language, in any form or by any      *
      * means, electronic, mechanical, magnetic, optical, chemical,   *
      * manual or otherwise, without the prior written permission of: *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      *
      *****************************************************************
      * Source Member: MFCATXPT.CBL
      * Copy Files:    None
      * Calls to:      None
      *****************************************************************
      * This program will read the Micro Focus CATALOG.DAT File and
      * write file information to a CSV and/or FFL File.
      *
      *                                   Record    Record     Key
      *  Function  Name     Organization  Format    Max-Min  Pos-Len
      *  INPUT     CATGET01 INDEXED       VARIABLE   10476    00001
      *                                              00476    00052
      *  OUTPUT    LONAPCSV ASCII/CRLF    VARIABLE   01024
      *  OUTPUT    LONAPFFL Sequential    FIXED      01024
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CATGET01-FILE  ASSIGN TO       CATGET01
                  ORGANIZATION  IS INDEXED
                  ACCESS MODE   IS SEQUENTIAL
                  RECORD KEY    IS CATGET01-KEY-01
                  ALTERNATE KEY is CATGET01-ALT-01 with duplicates
                  FILE STATUS   IS CATGET01-STATUS.
           SELECT LONAPCSV-FILE  ASSIGN TO       LONAPCSV
                  ORGANIZATION  IS LINE SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS LONAPCSV-STATUS.
           SELECT LONAPFFL-FILE  ASSIGN TO       LONAPFFL
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS LONAPFFL-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  CATGET01-FILE
           DATA RECORD    IS CATGET01-REC
           RECORDING MODE IS V
           RECORD VARYING FROM 00476 TO 10476
           DEPENDING ON CATGET01-LRECL.

       01  CATGET01-REC.
           05  CATGET01-KEY-01  PIC X(00052).
           05  CATGET01-ALT-01  PIC X(00260).
           05  CATGET01-DATA-01 PIC X(10164).

       FD  LONAPCSV-FILE
           DATA RECORD    IS LONAPCSV-REC.
       01  LONAPCSV-REC.
           05  LONAPCSV-DATA-01 PIC X(01024).

       FD  LONAPFFL-FILE
           DATA RECORD    IS LONAPFFL-REC.
       COPY LONAPFFL.

      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* MFCATXPT '.
           05  T2 pic X(34) value 'Export File Names and Properties  '.
           05  T3 pic X(10) value ' v11.05.08'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* MFCATXPT '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  CATGET01-STATUS.
           05  CATGET01-STATUS-L     pic X.
           05  CATGET01-STATUS-R     pic X.
       01  CATGET01-EOF              pic X       value 'N'.
       01  CATGET01-OPEN-FLAG        pic X       value 'C'.

       01  LONAPCSV-STATUS.
           05  LONAPCSV-STATUS-L     pic X.
           05  LONAPCSV-STATUS-R     pic X.
       01  LONAPCSV-EOF              pic X       value 'N'.
       01  LONAPCSV-OPEN-FLAG        pic X       value 'C'.

       01  LONAPFFL-STATUS.
           05  LONAPFFL-STATUS-L     pic X.
           05  LONAPFFL-STATUS-R     pic X.
       01  LONAPFFL-EOF              pic X       value 'N'.
       01  LONAPFFL-OPEN-FLAG        pic X       value 'C'.

       01  CATGET01-LRECL    pic 9(5)    value 10476.
       01  LONAPCSV-LRECL    pic 9(5)    value 01024.
       01  LONAPFFL-LRECL    pic 9(5)    value 01024.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* MFCATXPT '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)    value 'MFCATXPT'.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  IX-P1                pic 9(9)       value 0.
       01  IX-P2                pic 9(9)       value 0.
       01  IX-P3                pic 9(9)       value 0.
       01  IX-L1                pic 9(9)       value 0.
       01  DELIMITER-BYTE       pic X          value ','.
       01  O-FLAG               pic X(3)       value 'CSV'.
       01  SELECT-FLAG          pic X          value 'N'.

       01 WORK-64               pic X(64)      value SPACES.

       01  LONAPCSV-HEADER.
           05  FILLER pic X(2)  value '00'.                             col-A
           05  FILLER pic X     value ','.
           05  FILLER pic X(30) value 'DSN or VSAM Cluster (54 Bytes)'. col-B
           05  FILLER pic X     value ','.
           05  FILLER pic X(7)  value 'DD Name'.                        col-C
           05  FILLER pic X     value ','.
           05  FILLER pic X(5)  value 'DSORG'.                          col-D
           05  FILLER pic X     value ','.
           05  FILLER pic X(5)  value 'RECFM'.                          col-E
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'lrecl-MIN'.                      col-F
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'lrecl-MAX'.                      col-G
           05  FILLER pic X     value ','.
           05  FILLER pic X(6)  value 'KeyPos'.                         col-H
           05  FILLER pic X     value ','.
           05  FILLER pic X(6)  value 'KeyLen'.                         col-I
           05  FILLER pic X     value ','.
           05  FILLER pic X(14) value 'VSAM Data Name'.                 col-J
           05  FILLER pic X     value ','.
           05  FILLER pic X(15) value 'VSAM Index Name'.                col-K
           05  FILLER pic X     value ','.
           05  FILLER pic X(12) value 'Override Job'.                   col-L
           05  FILLER pic X     value ','.
           05  FILLER pic X(10) value 'User Job 1'.                     col-M
           05  FILLER pic X     value ','.
           05  FILLER pic X(10) value 'User Job 2'.                     col-N
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-S1'.                      col-O
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-S2'.                      col-P
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-M1'.                      col-Q
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-M2'.                      col-R
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-M3'.                      col-S
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-M4'.                      col-T
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-X1'.                      col-U
           05  FILLER pic X     value ','.
           05  FILLER pic X(9)  value 'Extend-X2'.                      col-V
           05  FILLER pic X     value ','.


       01  PAPICNTL-GROUP.
           05  PAPICNTL-CONTROL-01 pic X       value 'Y'.
           05  PAPICNTL-CONTROL-02 pic X       value 'N'.
           05  PAPICNTL-CONTROL-03 pic X       value 'N'.
           05  PAPICNTL-CONTROL-04 pic X       value 'N'.
           05  PAPICNTL-CONTROL-05 pic X       value 'N'.
           05  PAPICNTL-CONTROL-06 pic X       value 'N'.
           05  PAPICNTL-CONTROL-07 pic X       value 'N'.
           05  PAPICNTL-CONTROL-08 pic X       value 'N'.
           05  PAPICNTL-ISOLATE    pic X       value '/'.
           05  PAPICNTL-MONITOR-01 pic X       value 'N'.
           05  PAPICNTL-MONITOR-02 pic X       value 'N'.
           05  PAPICNTL-MONITOR-03 pic X       value 'N'.
           05  PAPICNTL-MONITOR-04 pic X       value 'N'.
           05  PAPICNTL-MONITOR-05 pic X       value 'N'.
           05  PAPICNTL-MONITOR-06 pic X       value 'N'.
           05  PAPICNTL-MONITOR-07 pic X       value 'N'.
           05  PAPICNTL-MONITOR-08 pic X       value 'N'.

       01  NUM-05-ALPHA.
           05  NUM-05-VALUE    pic 9(5)        value 0.

       01  CATGET01-TOTAL.
           05  CATGET01-RDR  pic 9(9)  value 0.
           05  filler        pic X(3)  value ' - '.
           05  filler        pic X(23) value 'Line count for CATGET01'.
       01  LONAPCSV-TOTAL.
           05  LONAPCSV-ADD  pic 9(9)  value 0.
           05  filler        pic X(3)  value ' - '.
           05  filler        pic X(23) value 'Line count for LONAPCSV'.
       01  LONAPFFL-TOTAL.
           05  LONAPFFL-ADD  pic 9(9)  value 0.
           05  filler        pic X(3)  value ' - '.
           05  filler        pic X(23) value 'Line count for LONAPFFL'.

       COPY MVSCAT02.
       COPY PAENVARS.

      *****************************************************************
       PROCEDURE DIVISION.
           perform FIRST-TIME-LOGIC
           perform CATGET01-OPEN
           if  PAPICNTL-CONTROL-01 = 'Y'
               perform LONAPCSV-OPEN
           end-if
           if  PAPICNTL-CONTROL-02 = 'Y'
               perform LONAPFFL-OPEN
           end-if
           if  PAPICNTL-CONTROL-03 = 'Y'
               move LONAPCSV-HEADER to LONAPCSV-REC
               perform LONAPCSV-WRITE
           end-if

           perform until CATGET01-STATUS not = '00'
               perform CATGET01-READ
               if  CATGET01-STATUS = '00'
                   add 1 to CATGET01-RDR
                   move CATGET01-REC to CATLG-RECORD-01
                   perform POSSIBLE-SELECT
                   if  SELECT-FLAG = 'Y'
                       perform BUILD-OUTPUT-RECORDS
                   end-if
               end-if
           end-perform

           move CATGET01-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move LONAPCSV-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           if  PAPICNTL-CONTROL-02 = 'Y'
               perform LONAPFFL-CLOSE
           end-if
           if  PAPICNTL-CONTROL-01 = 'Y'
               perform LONAPCSV-CLOSE
           end-if
           perform CATGET01-CLOSE
           GOBACK.

      *****************************************************************
       BUILD-OUTPUT-RECORDS.
           perform CREATE-DD-NAME
           if  PAPICNTL-CONTROL-01 = 'Y'
               perform BUILD-LONAPCSV-RECORD
               perform LONAPCSV-WRITE
               if  LONAPCSV-STATUS = '00'
                   add 1 to LONAPCSV-ADD
               end-if
           end-if
           if  PAPICNTL-CONTROL-02 = 'Y'
               perform BUILD-LONAPFFL-RECORD
               perform LONAPFFL-WRITE
               if  LONAPFFL-STATUS = '00'
                   add 1 to LONAPFFL-ADD
               end-if
           end-if
           exit.

      *****************************************************************
       BUILD-LONAPCSV-RECORD.
      *>   Extract CALL process...
           add 1 to ZERO giving IX-P1
           move all SPACES to LONAPCSV-REC
      *    String Move, Column-A, Level Number or Record ID...          col-A
           add 2 to ZERO giving IX-L1
           move '01' to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-B, DSN or Data Set Name...               col-B
           add 00052 to ZERO giving IX-L1
           move CATLG-DSN to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-C, DSN or Data Set Name...               col-C
           add 8 to ZERO giving IX-L1
           move WORK-64(1:IX-L1) to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-D, DSORG or Data Set Organization...     col-D
           add length of CATLG-DSORG to ZERO giving IX-L1
           move CATLG-DSORG to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-E, RECFM or Record Format...,            col-E
           add length of CATLG-RECFM to ZERO giving IX-L1
           move CATLG-RECFM to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-F, LRECL or Logical Record Length, MIN   col-F
           add 5 to ZERO giving IX-L1
           add CATLG-LRECL-MIN to ZERO giving NUM-05-VALUE
           move NUM-05-ALPHA to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-G, LRECL or Logical Record Length, MAX   col-G
           add 5 to ZERO giving IX-L1
           add CATLG-LRECL-MAX to ZERO giving NUM-05-VALUE
           move NUM-05-ALPHA to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-H, KSDS Key Position                     col-H
           add 5 to ZERO giving IX-L1
           if  CATLG-RECFM = 'KS'
               add CATLG-VSAM-KEY-OFFSET to 1 giving NUM-05-VALUE
               move NUM-05-ALPHA to LONAPCSV-REC(IX-P1:IX-L1)
           else
               move SPACES to LONAPCSV-REC(IX-P1:IX-L1)
           end-if
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-I, KSDS Key Length                       col-I
           add 5 to ZERO giving IX-L1
           if  CATLG-RECFM = 'KS'
               add CATLG-VSAM-KEY-LENGTH to ZERO giving NUM-05-VALUE
               move NUM-05-ALPHA to LONAPCSV-REC(IX-P1:IX-L1)
           else
               move SPACES to LONAPCSV-REC(IX-P1:IX-L1)
           end-if
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-J, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-K, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-L, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-M, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-N, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-O, EXT for Dynamic PDS...
           if CATLG-DSORG = 'PO  '
              move CATLG-VARIABLE(9)  to LONAPCSV-REC(IX-P1:1)
              add 1 to IX-P1
              move CATLG-VARIABLE(10) to LONAPCSV-REC(IX-P1:1)
              add 1 to IX-P1
              move CATLG-VARIABLE(11) to LONAPCSV-REC(IX-P1:1)
              add 1 to IX-P1
              perform CALCULATE-NEXT-POSITION
           else
              perform CALCULATE-NEXT-POSITION
           end-if
      *    String Move, Column-P, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-Q, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-R, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-S, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-T, WIP
           perform CALCULATE-NEXT-POSITION
      *    String Move, Column-U, WIP
           perform CALCULATE-NEXT-POSITION

      *    String Move, Column-V, PC Data Set Name...
           add length of CATLG-PC-DSN to ZERO giving IX-L1
           move CATLG-PC-DSN to LONAPCSV-REC(IX-P1:IX-L1)
           perform CALCULATE-NEXT-POSITION

           exit.

      *****************************************************************
       BUILD-LONAPFFL-RECORD.
           move all SPACES      to LONAPFFL-REC
           move '01'            to LONAPFFL-LEVEL-CHR                   col-A
           move CATLG-DSN       to LONAPFFL-DSN                         col-B
           move WORK-64(1:8)    to LONAPFFL-DD-NAME                     col-C
           move CATLG-DSORG     to LONAPFFL-DSORG                       col-D
           move CATLG-RECFM     to LONAPFFL-RECFM                       col-E
           add  CATLG-LRECL-MIN to ZERO giving LONAPFFL-LRECL-MIN       col-F
           add  CATLG-LRECL-MAX to ZERO giving LONAPFFL-LRECL-MAX       col-G
           if  CATLG-RECFM = 'KS'
               add CATLG-VSAM-KEY-OFFSET to 1 giving LONAPFFL-KEYPOS    col-H
               add CATLG-VSAM-KEY-LENGTH to 1 giving LONAPFFL-KEYLEN    col-I
           else
               move ZEROES to LONAPFFL-KEYPOS                           col-H
               move ZEROES to LONAPFFL-KEYLEN                           col-I
           end-if

           if CATLG-DSORG = 'PO  '
              move CATLG-VARIABLE(9)  to LONAPFFL-EXTENDED-S1(1:1)      col-O
              move CATLG-VARIABLE(10) to LONAPFFL-EXTENDED-S1(2:1)      col-O
              move CATLG-VARIABLE(11) to LONAPFFL-EXTENDED-S1(3:1)      col-O
           end-if

           move CATLG-PC-DSN to LONAPFFL-EXTENDED-X2                    col-V


           exit.
      *
      *****************************************************************
       CALCULATE-NEXT-POSITION.
           if  O-FLAG = 'CSV'
               add IX-L1 to IX-P1
               if  IX-P1 > 1
                   perform until LONAPCSV-REC(IX-P1 - 1:1) not = SPACE
                              or IX-P1 < 1
                     subtract 1 from IX-P1
                   end-perform
               end-if
               move DELIMITER-BYTE to LONAPCSV-REC(IX-P1:1)
               add 1 to IX-P1
           else
               add IX-L1 to IX-P1
           end-if
           exit.
           add 01024 to ZERO giving LONAPCSV-LRECL
           exit.
      *
      *****************************************************************
       CREATE-DD-NAME.
           add 1 to ZERO giving IX-P2
           add 1 to ZERO giving IX-P3
           move SPACES to WORK-64
           perform until IX-P2 > 44
                      or CATLG-DSNAME(IX-P2:1) = ' '
             if  CATLG-DSNAME(IX-P2:1) = '.'
                 add 1 to IX-P2
                 add 1 to ZERO giving IX-P3
                 move SPACES to WORK-64
             else
                 move CATLG-DSNAME(IX-P2:1) to WORK-64(IX-P3:1)
                 add 1 to IX-P2
                 add 1 to IX-P3
             end-if
           end-perform

           exit.
      *
      *****************************************************************
       FIRST-TIME-LOGIC.
           perform Z-POST-COPYRIGHT
           move 'GET'         to ENV-VAR-REQUEST
           move 'SIMOCNTL'    to ENV-VAR-NAME
           call 'MFENVARS' using ENV-VAR-PASSAREA
           if  ENV-VAR-RESPOND = '0000'
           and ENV-VAR-VALUE not = SPACES
           and ENV-VAR-VALUE(9:1) = '/'
               move ENV-VAR-VALUE to PAPICNTL-GROUP
           end-if
           move ZERO to RETURN-CODE
           exit.
      *
      *****************************************************************
       POSSIBLE-SELECT.
           move 'N' to SELECT-FLAG
      *    Eliminate Spool FIle ENtryies
           if  CATLG-CATALOGED not = 'S'
               if  CATLG-DSORG = 'PDSM'
               or                'PO  '
               or                'PS  '
               or                'GDG '
               or                'IS  '
                   move 'Y' to SELECT-FLAG
               end-if
               if  CATLG-DSORG = 'VSAM'
               and CATLG-EXTENDED-TYPE = 'C'
                   move 'Y' to SELECT-FLAG
               end-if
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       CATGET01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CATGET01-FILE
           if  CATGET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with CATGET01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CATGET01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CATGET01-READ.
           read CATGET01-FILE
           if  CATGET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CATGET01-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CATGET01-EOF
               else
                   move 'READ Failure with CATGET01' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CATGET01-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CATGET01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CATGET01-FILE
           if  CATGET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CATGET01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with CATGET01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CATGET01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File, LONAPCSV                    *
      *****************************************************************
       LONAPCSV-WRITE.
           if  LONAPCSV-OPEN-FLAG = 'C'
               perform LONAPCSV-OPEN
           end-if
           write LONAPCSV-REC
           if  LONAPCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  LONAPCSV-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with LONAPCSV' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LONAPCSV-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT LONAPCSV-FILE
           if  LONAPCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to LONAPCSV-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with LONAPCSV' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LONAPCSV-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close LONAPCSV-FILE
           if  LONAPCSV-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to LONAPCSV-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with LONAPCSV' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPCSV-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File, LONAPFFL                    *
      *****************************************************************
       LONAPFFL-WRITE.
           if  LONAPFFL-OPEN-FLAG = 'C'
               perform LONAPFFL-OPEN
           end-if
           write LONAPFFL-REC
           if  LONAPFFL-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  LONAPFFL-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with LONAPFFL' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPFFL-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LONAPFFL-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT LONAPFFL-FILE
           if  LONAPFFL-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to LONAPFFL-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with LONAPFFL' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPFFL-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LONAPFFL-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close LONAPFFL-FILE
           if  LONAPFFL-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to LONAPFFL-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with LONAPFFL' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LONAPFFL-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
