      *set assign(external) nooptional-file
       IDENTIFICATION DIVISION.
       PROGRAM-ID.    MFEVENTS.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      * SOURCE MODULE MFEVENTS.CBL
      *****************************************************************
      *
      * MFEVENTS - Displays a message and does a STOP RUN.
      *
      * DESCRIPTION
      * -----------
      * This program will display a message and force an ABEND with
      * a GOBACK or STOP RUN. The RETURN-CODE will be set to 16.
      *
      * This program is for use in a Micro Focus environment.
      *
      ****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 SimoTime, Created program.
      * 1989/02/27 SimoTime, no changes to date
      *
      *****************************************************************
      *
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* MFEVENTS '.
           05  T2 pic X(34) value 'Display the Micro Focus call stack'.
           05  T3 pic X(10) value ' v10.06.08'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* MFEVENTS '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* MFEVENTS '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-01 pic X(68)   value SPACES.
               10  MESSAGE-TEXT-02 pic X(177)  value SPACES.

       01  MSG-CALLING-NAME-STMT.
           05  FILLER              pic X(2)  value '* '.
           05  MSG-PREVIOUS-NAME   pic X(8)  value 'MFEVENTS'.
           05  FILLER              pic X(08) value ' program'.
           05  FILLER              pic X(11) value ' called by '.
           05  MSG-CALLING-NAME    pic X(8).

       01  LOOP-LIMIT              pic 9(3)  value 50.
       01  LOOP-COUNT              pic 9(3)  value 0.

       01  GPI-GROUP.
           05  GPI-FUNCTION        pic x(4) comp-5.
           05  GPI-PARAM-BLOCK.
               10  GPI-SIZE        pic x(4) comp-5 value 20.
               10  GPI-FLAGS       pic x(4) comp-5 value 1.
               10  GPI-HANDLE      usage pointer.
               10  GPI-PROG-ID     usage pointer.
               10  GPI-ATTRS       pic x(4) comp-5.
           05  GPI-NAME-BUF        pic x(128).
           05  GPI-NAME-LEN        pic x(4) comp-5 value 128.
           05  GPI-STATUS-CODE     PIC x(2) comp-5.
      *
      *    0    Success.
      *    500  End of information (returned by function 2 when there
      *         is no caller of the currently associated program, or
      *         by function 5 when no more entry points exist).
      *    1001 Invalid GPI-HANDLE input.
      *    1009 Invalid parameter.
      *    1013 Buffer too small for information to be returned

      *****************************************************************
       PROCEDURE DIVISION.
      *    The following will cause the ANIMATOR to be started. By
      *    using the View, Debug Windows and Call Stack you can see
      *    the call progression that got you here.
      *    Note: for this to work the asterisk in column 7 must be
      *          removed.
      *    call 'CBL_DEBUGBREAK'

           move SIM-TITLE to MESSAGE-BUFFER
           perform Z-DISPLAY-CONSOLE-MESSAGE
           move SIM-COPYRIGHT to MESSAGE-BUFFER
           perform Z-DISPLAY-CONSOLE-MESSAGE

      *    To chase the call stack...
           perform CHASE-CALL-STACK
           GOBACK.

      *****************************************************************
       CHASE-CALL-STACK.
      *    Get handle for current program...
           move 0 to GPI-FUNCTION
           move 1 to GPI-FLAGS
           move SPACES to GPI-NAME-BUF
           move 128 to GPI-NAME-LEN
           call 'CBL_GET_PROGRAM_INFO' using
                                       by value      GPI-FUNCTION
                                       by reference  GPI-PARAM-BLOCK
                                       by reference  GPI-NAME-BUF
                                       by reference  GPI-NAME-LEN
                                       returning     GPI-STATUS-CODE
      *    Prepare to chase call stack...
           move 2 to GPI-FUNCTION
           move 3 to GPI-FLAGS
      *    Chase the CALL stack...
           perform varying LOOP-COUNT from 1 by 1
             until LOOP-COUNT > LOOP-LIMIT
             or    GPI-STATUS-CODE not = 0
             move SPACES to GPI-NAME-BUF
             move 128 to GPI-NAME-LEN
             call 'CBL_GET_PROGRAM_INFO'
                   using
                   by value      GPI-FUNCTION
                   by reference  GPI-PARAM-BLOCK
                   by reference  GPI-NAME-BUF
                   by reference  GPI-NAME-LEN
                   returning     GPI-STATUS-CODE
             if  GPI-STATUS-CODE = 0
                 move GPI-NAME-BUF to MESSAGE-TEXT
                 perform Z-DISPLAY-CONSOLE-MESSAGE
             end-if
           end-perform
           exit.

      *****************************************************************
      * Display a message generated by this program.                  *
      * The "upon console" will cause the message to be displayed     *
      * on the system console. Mainframe system operators usually     *
      * discourage this technique so minimize the number of messages. *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-02 = SPACES
      *       display MESSAGE-BUFFER(1:79) upon console
              display MESSAGE-BUFFER(1:79)
           else
      *       display MESSAGE-BUFFER       upon console
              display MESSAGE-BUFFER
           end-if
           move SPACES to MESSAGE-TEXT
           exit.
