       Identification Division.
       Program-id. MFWAITER.
       Author.     SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: SIMOTXTN.CBL
      * Copy Files:    PASSTXTN.CPY
      *****************************************************************
      *
      * SIMOTXTN - A called routine for digit to text conversions.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard COBOL calling procedures.
      *
      * DESCRIPTION
      * -----------
      *
      * To execute as a standalone program via JCL the parameter is
      * supplied via the PARM= on the EXEC card.
      *
      *   //STEP0010 EXEC PGM=MFWAITER,PARM='hh:mm:ss'
      * or
      *   //STEP0010 EXEC PGM=MFWAITER,PARM='hh:mm:ss:cc'
      *
      * Possible return-codes:
      *
      *   0000 - successfull completion of request
      *   0016 - parameter is not numeric or is not in range between
      *          and including 00:00:00:00 through 23:59:59:99
      *
      ****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1999/02/27 Simmons, Created program.
      * 1999/02/27 Simmons, no changes to date
      *
      *****************************************************************
      *

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
           CALL-CONVENTION 74 is WINAPI.

       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* MFWAITER '.
           05  T2 pic X(34) value 'Wait the Specified Amount of Time '.
           05  T3 pic X(10) value ' v10.06.24'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* MFWAITER '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* MFWAITER '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* MFWAITER '.
           05  C2 pic X(32) value 'Please forward your comments or '.
           05  C3 pic X(32) value 'suggestions to helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER  pic X(11)   value '* MFWAITER '.
           05  MESSAGE-TEXT    pic X(68).

       01  WIN-MILLISECS       pic  X(04)  comp-5.

       01  W-TIME-MSG-LINE.
           05  W-TEXT          PIC x(8)    value SPACES.
           05  FILLER          PIC X(16)   value ' Wait State for '.
           05  W-TIME.
               10  W-TIME-HH   pic 9(2)    value 0.
               10  FILLER      pic X.
               10  W-TIME-MM   pic 9(2)    value 0.
               10  FILLER      pic X.
               10  W-TIME-SS   pic 9(2)    value 0.
               10  FILLER      pic X.
               10  W-TIME-CC   pic 9(2)    value 0.

       01  BEHAVIOR-FLAGS.
           05  BF-DEBUG-001    pic X       value 'N'.
           05  BF-COPYRIGHT    pic X       value 'N'.

      *****************************************************************
       LINKAGE SECTION.
       COPY PAWAITER.

      *****************************************************************
       PROCEDURE DIVISION using MFWAITER-PASS-AREA.
           if  BF-COPYRIGHT = 'Y'
               perform Z-POST-COPYRIGHT
           end-if

           move 8 to RETURN-CODE
           move '00:00:00:00' to W-TIME

           evaluate MFWAITER-LENGTH
             when  8    move MFWAITER-TIME(1:2) to W-TIME(01:2)
                        move MFWAITER-TIME(4:2) to W-TIME(04:2)
                        move MFWAITER-TIME(7:2) to W-TIME(07:2)
                        move ZERO to RETURN-CODE
             when 11    move MFWAITER-TIME to W-TIME
                        move ZERO to RETURN-CODE
             when other add 16 to ZERO giving RETURN-CODE
                        GOBACK
           end-evaluate

           if W-TIME-HH not NUMERIC
           or W-TIME-MM not NUMERIC
           or W-TIME-SS not NUMERIC
           or W-TIME-CC not NUMERIC
           or W-TIME-HH > 23                    *> hours
           or W-TIME-MM > 59                    *> minutes
           or W-TIME-SS > 59                    *> seconds
               move 16 to RETURN-CODE
               GOBACK
           end-if

           if  BF-DEBUG-001 = 'Y'
               move 'Starting' to W-TEXT
               move W-TIME-MSG-LINE to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

           COMPUTE WIN-MILLISECS = (W-TIME-HH * 3600000)
                                 + (W-TIME-MM * 60000)
                                 + (W-TIME-SS * 1000)
                                 + (W-TIME-CC * 10)

      *    call WINAPI "Sleep" using by value WIN-MILLISECS
           call 'CBL_THREAD_SLEEP' using by value WIN-MILLISECS

           if  BF-DEBUG-001 = 'Y'
               move 'Finished' to W-TEXT
               move W-TIME-MSG-LINE to MESSAGE-TEXT
               perform Z-POST-MESSAGE
           end-if

           if  BF-COPYRIGHT = 'Y'
               perform Z-THANK-YOU
           end-if

           move 0 to RETURN-CODE
           GOBACK.

      *****************************************************************
      * The following Z-Routines perform administrative tasks
      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.

      *****************************************************************
       Z-POST-MESSAGE.
           display MESSAGE-BUFFER
           move SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
