       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SIMOABN0.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      * SOURCE MODULE SIMOABN0.CBL
      *****************************************************************
      *
      * SIMOABN0 - Displays a message and does a STOP RUN.
      *
      * DESCRIPTION
      * -----------
      * This program will display a message and force an ABEND with
      * a GOBACK or STOP RUN. The RETURN-CODE will be set to 16.
      *
      * This program is for use in a Micro Focus environment.
      *
      ****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 SimoTime, Created program.
      * 1989/02/27 SimoTime, no changes to date
      *
      *****************************************************************
      *
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* SIMOABN0 '.
           05  T2 pic X(34) value 'ABENDING, display the call stack. '.
           05  T3 pic X(10) value ' v08.01.24'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* SIMOABN0 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* SIMOABN0 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-01 pic X(68)   value SPACES.
               10  MESSAGE-TEXT-02 pic X(177)  value SPACES.

      *****************************************************************
       PROCEDURE DIVISION.
      *    The following will cause the ANIMATOR to be started. By
      *    using the View, Debug Windows and Call Stack you can see
      *    the call progression that got you here.
      *    Note: for this to work the asterisk in column 7 must be
      *          removed.
      *    call 'CBL_DEBUGBREAK'

           move SIM-TITLE to MESSAGE-BUFFER
           perform Z-DISPLAY-CONSOLE-MESSAGE
           move SIM-COPYRIGHT to MESSAGE-BUFFER
           perform Z-DISPLAY-CONSOLE-MESSAGE

      *    The following will call MFEVENTS to display the call stack
      *    for the Micro Focus environment.
           move 'Call Stack could not be processed...' to MESSAGE-TEXT
           call 'MFEVENTS' on exception
                           perform Z-DISPLAY-CONSOLE-MESSAGE
           end-call

           move 'Processing is being Terminated...   ' to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 16 to ZERO giving RETURN-CODE

      *    The STOP RUN will force an immediate ABEND.
           STOP RUN.

      *****************************************************************
      * Display a message generated by this program.                  *
      * The "upon console" will cause the message to be displayed     *
      * on the system console. Mainframe system operators usually     *
      * discourage this technique so minimize the number of messages. *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-02 = SPACES
      *       display MESSAGE-BUFFER(1:79) upon console
              display MESSAGE-BUFFER(1:79)
           else
      *       display MESSAGE-BUFFER       upon console
              display MESSAGE-BUFFER
           end-if
           move SPACES to MESSAGE-TEXT
           exit.
