       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SIMOHEX4.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used in *
      * any advertising or publicity pertaining to the use of the     *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: SIMOHEX4.CBL
      * Copy Files:    HEXTABLE.CPY
      *                PASSHEX4.CPY
      *****************************************************************
      *
      * PASSHEX4 - Create Hexadecimal Dump information.
      *
      *
      * DESCRIPTION
      * -----------
      * This program will scan the source buffer and create
      * HEX-Dump information plus ASCII and EBCDIC display info.
      *
      *           ************            ************
      *           * TXTHEXJ1 *            * TXTHEXE1 *
      *           ********jcl*            ********cmd*
      *                *                       *
      *                *                       *
      *           ************            ************
      *           * IEFBR14  *            * SIMOEXEC *
      *           ********utl*            ********cbl*
      *                *                       *
      *                *************************
      *                          *
      *                          *
      *    ************     ************     ************
      *    * TEXT0512 *-----* TXTHEXC1 *-----* QSAMHEXW *
      *    *******crlf*     ********cbl*     *******crlf*
      *                          *
      *                          *           ************
      *                          *------call-* SIMOHEX4 *
      *                          *           ********cbl*
      *                          *
      *                     ************
      *                     *   EOJ    *
      *                     ************
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1996/03/15 Simmons, Created program.
      * 1996/03/15 Simmons, No changes to date.
      *
      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  FIVE-BYTES              pic X(5).

       01  IDX-1                   pic 9(3)    BINARY.
       01  IDX-1R                  REDEFINES IDX-1.
           05  IDX-1R-01           pic X.
           05  IDX-1R-02           pic X.
       01  IDX-2                   pic 9(3)    BINARY.

       COPY HEXTABLE.

      *****************************************************************
       LINKAGE SECTION.
       COPY PASSHEX4.

      *****************************************************************
       PROCEDURE DIVISION using PASSHEX4-PASS-AREA.

           add 8 to ZERO giving PASSHEX4-RESULT

           if  PASSHEX4-LENGTH not NUMERIC
               add 128 to ZERO giving PASSHEX4-LENGTH
           end-if

           if  PASSHEX4-LENGTH > 1024
               add 128 to ZERO giving PASSHEX4-LENGTH
           end-if

           if  PASSHEX4-REQUEST = 'DUMP'
               perform DUMP-PROCESSING
           else
               add 16 to ZERO giving PASSHEX4-RESULT
           end-if

           GOBACK.

      *****************************************************************
      * The following routines are in alphabetical sequence.          *
      *****************************************************************
       DUMP-PROCESSING.
           move all SPACES to PASSHEX4-DUMP-INFO
           perform varying IDX-2 from 1 by 1
               until IDX-2 > PASSHEX4-LENGTH
               add 1 to ZERO giving IDX-1
               move PASSHEX4-SOURCE(IDX-2:1) to IDX-1R-02
               add 1 to IDX-1
               move TAB-X1(IDX-1) to FIVE-BYTES
               move FIVE-BYTES(1:1) to PASSHEX4-UPPER(IDX-2:1)
               move FIVE-BYTES(2:1) to PASSHEX4-LOWER(IDX-2:1)
               move FIVE-BYTES(3:1) to PASSHEX4-EBCDIC(IDX-2:1)
               move FIVE-BYTES(4:1) to PASSHEX4-ASCII(IDX-2:1)
           end-perform
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
