       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SIMOJUST.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: SIMOJUST.CBL
      * Copy Files:    PASSJUST.CPY
      *****************************************************************
      *
      * SIMOJUST - Justify (or position) a text string within a field
      * based on the caller's request to center, left or right justify.
      *
      * EXECUTION or CALLING PROTOCOL
      * -----------------------------
      * CALL 'SIMOJUST' USING JUST-PASS-AREA.
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1988/02/27 Simmons, Created program.
      * 1988/02/27 Simmons, No changes to date.
      *
      *****************************************************************
      *
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  Z-PTR-1             pic 9(3)    value 0.
       01  Z-PTR-2             pic 9(3)    value 0.
       01  Z-MAX-1             pic 9(3)    value 0.
       01  Z-MAX-2             pic 9(3)    value 0.
       01  FIRST-BYTE          pic 9(3)    value 0.
       01  FINAL-BYTE          pic 9(3)    value 0.
       01  LENGTH-OF-STRING    pic 9(3)    value 0.

      *****************************************************************
       LINKAGE SECTION.
       COPY PASSJUST.

      *****************************************************************
       PROCEDURE DIVISION using JUST-PASS-AREA.
           perform INITIALIZE-FIELDS

           perform until Z-PTR-1 > Z-MAX-1
               if  JUST-SOURCE(Z-PTR-1:1) not = SPACE
                   if  FIRST-BYTE = 0
                       add Z-PTR-1 to ZERO giving FIRST-BYTE
                   end-if
                   add Z-PTR-1 to ZERO giving FINAL-BYTE
               end-if
               add 1 to Z-PTR-1
           end-perform

           compute LENGTH-OF-STRING = FINAL-BYTE - FIRST-BYTE + 1

           evaluate JUST-REQUEST
             when 'CENTER  ' perform REQUEST-CENTER
             when 'LEFT    ' perform REQUEST-LEFT
             when 'RIGHT   ' perform REQUEST-RIGHT
             when other      add 8 to ZERO giving JUST-RESPOND
           end-evaluate

           GOBACK.

      *****************************************************************
       INITIALIZE-FIELDS.
           add 16 to ZERO giving JUST-RESPOND
           move ZERO to Z-PTR-1
           move ZERO to Z-PTR-2
           move ZERO to FIRST-BYTE
           move ZERO to FINAL-BYTE
           move ZERO to LENGTH-OF-STRING
           move SPACES to JUST-TARGET
           add length of JUST-SOURCE to ZERO giving Z-MAX-1
           add length of JUST-TARGET to ZERO giving Z-MAX-2
           exit.

      *****************************************************************
       REQUEST-CENTER.
           compute Z-PTR-2 = (Z-MAX-2 - LENGTH-OF-STRING) / 2 + 1
           move JUST-SOURCE(FIRST-BYTE:LENGTH-OF-STRING)
             to JUST-TARGET(Z-PTR-2:LENGTH-OF-STRING)
           move ZERO to JUST-RESPOND
           exit.

      *****************************************************************
       REQUEST-LEFT.
           add 1 to ZERO giving Z-PTR-2
           move JUST-SOURCE(FIRST-BYTE:LENGTH-OF-STRING)
             to JUST-TARGET(Z-PTR-2:LENGTH-OF-STRING)
           move ZERO to JUST-RESPOND
           exit.

      *****************************************************************
       REQUEST-RIGHT.
           compute Z-PTR-2 = (Z-MAX-2 - LENGTH-OF-STRING) + 1
           move JUST-SOURCE(FIRST-BYTE:LENGTH-OF-STRING)
             to JUST-TARGET( Z-PTR-2:LENGTH-OF-STRING)
           move ZERO to JUST-RESPOND
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
