      *****************************************************************
      *                TAB4STAT is a COBOL Copy File                  *
      *              Data Table for File Status Codes.                *
      *         Copyright (C) 1987-2019 SimoTime Technologies         *
      *                     All Rights Reserved                       *
      *****************************************************************
      *              Provided by SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      * The following table contains file status code information.    *
      * The intent of this table is to provide a brief description    *
      * of the file status code. For an expanded description refer to *
      * the documentation provided by the software vendor.            *
      *****************************************************************
      *
       01  STATUS-TABLE-OF-DATA.
           05  filler PIC X(56) value
           '0000, Successful completion                             '.
           05  filler PIC X(56) value
           '0002, Index File, identical or duplicate key value      '.
           05  filler PIC X(56) value
           '0004, Conflict, record length and fixed file attributes '.
           05  filler PIC X(56) value
           '0005, OPEN failure, referenced file is not found        '.
           05  filler PIC X(56) value
           '0006, WRITE failure, file that has been opened for input'.
           05  filler PIC X(56) value
           '0007, OPEN or CLOSE failure, REEL/UNIT for non-reel/unit'.
           05  filler PIC X(56) value
           '0008, Read failure, file opened for output              '.
           05  filler PIC X(56) value
           '0009, No room in directory or directory does not exist  '.
           05  filler PIC X(56) value
           '0010, No next logical record exists, end of the file    '.
           05  filler PIC X(56) value
           '0012, OPEN failure, file is already open                '.
           05  filler PIC X(56) value
           '0013, File not found                                    '.
           05  filler PIC X(56) value
           '0014, Requested relative record number > relative key   '.
           05  filler PIC X(56) value
           '0015, Too many indexed files open (MF)                  '.
           05  filler PIC X(56) value
           '0016, Too many device files open (MF)                   '.
           05  filler PIC X(56) value
           '0017, Record error: probably zero length (MF)           '.
           05  filler PIC X(56) value
           '0018, EOF before EOR or file open in wrong mode (MF)    '.
           05  filler PIC X(56) value
           '0019, Rewrite error: open mode or access mode wrong (MF)'.
           05  filler PIC X(56) value
           '0020, Device or resource busy (MF)                      '.
           05  filler PIC X(56) value
           '0021, Ascending key sequence has been violated          '.
           05  filler PIC X(56) value
           '0022, Indicates a duplicate key condition               '.
           05  filler PIC X(56) value
           '0023, Indicates no record found                         '.
           05  filler PIC X(56) value
           '0024, Relative or indexed files, a boundary violation   '.
           05  filler PIC X(56) value
           '0030, Failure, boundary, parity check, transmission     '.
           05  filler PIC X(56) value
           '0034, WRITE beyond defined boundaries of sequential file'.
           05  filler PIC X(56) value
           '0035, OPEN failure, specified file not found            '.
           05  filler PIC X(56) value
           '0037, OPEN failure, open mode specified is not supported'.
           05  filler PIC X(56) value
           '0038, OPEN failure, file previously closed with a lock  '.
           05  filler PIC X(56) value
           '0039, File Attributes, conflict of actual vs. specified '.
           05  filler PIC X(56) value
           '0041, OPEN failure, file is already opened              '.
           05  filler PIC X(56) value
           '0042, CLOSE failure, file already closed                '.
           05  filler PIC X(56) value
           '0043, DELETE or REWRITE attempt without a previous READ '.
           05  filler PIC X(56) value
           '0044, A boundary violation exists                       '.
           05  filler PIC X(56) value
           '0046, READ failure, no valid next record established    '.
           05  filler PIC X(56) value
           '0047, READ or START failure, not opened for INPUT or I-O'.
           05  filler PIC X(56) value
           '0048, A WRITE failure, not opened OUTPUT, EXTEND or I-O '.
           05  filler PIC X(56) value
           '0049, DELETE or REWRITE failure, file is not opened I-O '.
           05  filler PIC X(56) value
           '9000/00, No further information                         '.
           05  filler PIC X(56) value
           '9001/01, Insufficient buffer space or out of memory     '.
           05  filler PIC X(56) value
           '9002/02, File not open when access tried                '.
           05  filler PIC X(56) value
           '9003/03, Serial mode error                              '.
           05  filler PIC X(56) value
           '9004/04, Illegal file name                              '.
           05  filler PIC X(56) value
           '9005/05, Illegal device specification                   '.
           05  filler PIC X(56) value
           '9006/06, Attempt to write to a file opened for input    '.
           05  filler PIC X(56) value
           '9007/07, Disk space exhausted                           '.
           05  filler PIC X(56) value
           '9008/08, Attempt to input from a file opened for output '.
           05  filler PIC X(56) value
           '9009/09, No room in directory,  directory does not exist'.
           05  filler PIC X(56) value
           '9010/0A, File name not supplied                         '.
           05  filler PIC X(56) value
           '9012/0C, Attempt to open a file that is already open    '.
           05  filler PIC X(56) value
           '9013/0D, File not found                                 '.
           05  filler PIC X(56) value
           '9014/0E, Too many files open simultaneously             '.
           05  filler PIC X(56) value
           '9015/0F, Too many indexed files open                    '.
           05  filler PIC X(56) value
           '9016/10, Too many device files open                     '.
           05  filler PIC X(56) value
           '9017/11, Record error, probable zero record length      '.
           05  filler PIC X(56) value
           '9018/12, EOF before EOR or file open in wrong mode      '.
           05  filler PIC X(56) value
           '9019/13, Rewrite error: open mode or access mode wrong  '.
           05  filler PIC X(56) value
           '9020/14, Device or resource busy                        '.
           05  filler PIC X(56) value
           '9021/15, File is a directory                            '.
           05  filler PIC X(56) value
           '9022/16, Illegal or impossible access mode for OPEN     '.
           05  filler PIC X(56) value
           '9023/17, Illegal or impossible access mode for CLOSE    '.
           05  filler PIC X(56) value
           '9024/18, Disk I/O error                                 '.
           05  filler PIC X(56) value
           '9025/19, Operating system data error                    '.
           05  filler PIC X(56) value
           '9026/1A, Block I/O error                                '.
           05  filler PIC X(56) value
           '9027/1B, Device not available                           '.
           05  filler PIC X(56) value
           '9028/1C, No space on device                             '.
           05  filler PIC X(56) value
           '9029/1D, Attempt to delete open file                    '.
           05  filler PIC X(56) value
           '9030/1E, File system is read only                       '.
           05  filler PIC X(56) value
           '9031/1F, Not owner of file                              '.
           05  filler PIC X(56) value
           '9032/20, Too many indexed files, or no such process     '.
           05  filler PIC X(56) value
           '9033/21, Physical I/O error                             '.
           05  filler PIC X(56) value
           '9034/22, Incorrect mode or file descriptor              '.
           05  filler PIC X(56) value
           '9035/23, File access attempt with incorrect permission  '.
           05  filler PIC X(56) value
           '9036/24, File already exists                            '.
           05  filler PIC X(56) value
           '9037/25, File access denied                             '.
           05  filler PIC X(56) value
           '9038/26, Disk not compatible                            '.
           05  filler PIC X(56) value
           '9039/27, File not compatible                            '.
           05  filler PIC X(56) value
           '9040/28, Language initialization not set up correctly   '.
           05  filler PIC X(56) value
           '9041/29, Corrupt index file                             '.
           05  filler PIC X(56) value
           '9042/2A, Attempt to write on broken pipe                '.
           05  filler PIC X(56) value
           '9043/2B, File information missing for indexed file      '.
           05  filler PIC X(56) value
           '9044/2C, Attempt open, NLS file and incompatible program'.
           05  filler PIC X(56) value
           '9045/2D, Index structure overflow maximum duplicate keys'.
           05  filler PIC X(56) value
           '9065/41, File locked                                    '.
           05  filler PIC X(56) value
           '9066/42, Attempt to add duplicate key to indexed file   '.
           05  filler PIC X(56) value
           '9067/43, Indexed file not open                          '.
           05  filler PIC X(56) value
           '9068/44, Record locked                                  '.
           05  filler PIC X(56) value
           '9069/45, Illegal argument to ISAM module                '.
           05  filler PIC X(56) value
           '9070/46, Too many indexed files open                    '.
           05  filler PIC X(56) value
           '9071/47, Bad indexed file format                        '.
           05  filler PIC X(56) value
           '9072/48, End of indexed file                            '.
           05  filler PIC X(56) value
           '9073/49, No record found in indexed file                '.
           05  filler PIC X(56) value
           '9074/4A, No current record in indexed file              '.
           05  filler PIC X(56) value
           '9075/4B, Indexed data file name too long                '.
           05  filler PIC X(56) value
           '9076/4C, Internal ISAM module failure                   '.
           05  filler PIC X(56) value
           '9077/4D, Illegal key description in indexed file        '.
           05  filler PIC X(56) value
           '9081/51, Key already exists in indexed file             '.
           05  filler PIC X(56) value
           '9092/5C, PUT/update or ERASE without a previous GET    '.
           05  filler PIC X(56) value
           '9100/64, Invalid file operation                         '.
           05  filler PIC X(56) value
           '9101/65, Illegal operation on an indexed file           '.
           05  filler PIC X(56) value
           '9102/66, Sequential file, non-integral number of records'.
           05  filler PIC X(56) value
           '9104/68, Null file name used in a file operation        '.
           05  filler PIC X(56) value
           '9105/69, Memory allocation error                        '.
           05  filler PIC X(56) value
           '9124/7C, Connection failure to remote system (MF)       '.
           05  filler PIC X(56) value
           '9125/7D, Connection to remote file server failed (MF)   '.
           05  filler PIC X(56) value
           '9129/81, Attempt to access record zero of relative file '.
           05  filler PIC X(56) value
           '9135/87, File must not exist                            '.
           05  filler PIC X(56) value
           '9138/8A, File closed with lock - cannot be opened       '.
           05  filler PIC X(56) value
           '9139/8B, Record length or key data inconsistency        '.
           05  filler PIC X(56) value
           '9141/8D, File already open - cannot be opened           '.
           05  filler PIC X(56) value
           '9142/8E, File not open - cannot be closed               '.
           05  filler PIC X(56) value
           '9143/8F, REWRITE/DELETE not preceded by successful READ '.
           05  filler PIC X(56) value
           '9146/92, No current record defined for sequential read  '.
           05  filler PIC X(56) value
           '9147/93, Wrong open mode or access mode for READ/START  '.
           05  filler PIC X(56) value
           '9148/94, Wrong open mode or access mode for WRITE       '.
           05  filler PIC X(56) value
           '9149/95, Wrong open or access mode for REWRITE/ DELETE  '.
           05  filler PIC X(56) value
           '9150/96, Program abandoned at user request              '.
           05  filler PIC X(56) value
           '9151/97, Random read on sequential file                 '.
           05  filler PIC X(56) value
           '9152/98, REWRITE on file not opened I-O                 '.
           05  filler PIC X(56) value
           '9158/9E, Attempt to REWRITE to a line-sequential file.  '.
           05  filler PIC X(56) value
           '9159/9F, Malformed line sequential-file                 '.
           05  filler PIC X(56) value
           '9161/A1, File header not found                          '.
           05  filler PIC X(56) value
           '9173/AD, Called program not found                       '.
           05  filler PIC X(56) value
           '9180/B4, End-of-file marker error                       '.
           05  filler PIC X(56) value
           '9182/B6, Console input or output open in wrong direction'.
           05  filler PIC X(56) value
           '9183/B7, Attempt to open line sequential file for I-O   '.
           05  filler PIC X(56) value
           '9188/BC, File name too large                            '.
           05  filler PIC X(56) value
           '9193/C1, Error in variable length count                 '.
           05  filler PIC X(56) value
           '9194/C2, File size too large                            '.
           05  filler PIC X(56) value
           '9195/C3, DELETE/REWRITE not preceded by a READ          '.
           05  filler PIC X(56) value
           '9196/C4, Record number too large, relative/indexed file '.
           05  filler PIC X(56) value
           '9210/D2, File is closed with lock                       '.
           05  filler PIC X(56) value
           '9213/D5, Too many locks                                 '.
           05  filler PIC X(56) value
           '9218/DA, Malformed MULTIPLE REEL/UNIT file              '.
           05  filler PIC X(56) value
           '9219/DB, Operating system shared file limit exceeded    '.

      *****************************************************************
       01  STATUS-TABLE-01  REDEFINES STATUS-TABLE-OF-DATA.
           05  STATUS-CELL  OCCURS 133 TIMES.
               10  STATUS-CELL-04  pic X(4).
               10  STATUS-CELL-52  pic X(52).

       01  STATUS-CELLS-MAXIMUM    pic 9(5)    value 133.
       01  STATUS-IDX              pic 9(5)    value 0.
      ***  TAB4STAT - End-of-Copy File - - - - - - - - - - - TAB4STAT *
      *****************************************************************
      *
